/* "Followers Adventure" -- an adventure game */
/* Copyright (c) 1982 by Roger M. Wilcox */
// MS Visual C++ port copyright (c) 2002 by Roger M. Wilcox

#include <windows.h>
#include "resource.h"
#include <stdio.h>
#include <tchar.h>

#define MAX_LOADSTRING 100
#define MAX_COMMAND_STRING 40
#define EN_USERPRESSEDENTER 747

#define	HELD	(-1)
#define	MAXINV	(7)
enum direction { NORTH, SOUTH, EAST, WEST, UP, DOWN };

struct place
{
	TCHAR	name[200];
	int		exit[6];
};

struct object
{
	TCHAR	name[40];
	int		room;
	int		score;
};

#define	NUM_PLACES	18
#define NUM_OBJECTS	26
#define NUM_VERBS	39
#define NUM_NOUNS	46

struct place p[] =
{
	{"", NULL, NULL, NULL, NULL, NULL, NULL },
	{"on a long dirt road", NULL, NULL, 2, 3, NULL, NULL },
	{"on top of a hill with a horse trail", 5, NULL, 6, 1, NULL, NULL },
	{"in a manger", NULL, NULL, 1, NULL, NULL, NULL },
	{"in a small town with a horse trail", NULL, 8, 7, 11, NULL, NULL },
	{"in a small forest", NULL, 2, NULL, NULL, NULL, NULL },
	{"in a vast meeting & battle ground", NULL, NULL, NULL, 2, NULL, NULL },
	{"in a peasant's home", NULL, NULL, NULL, 4, NULL, NULL },
	{"in a small town", 4, 10, 9, 14, NULL, NULL },
	{"in a deserted graveyard", NULL, NULL, NULL, 8, NULL, NULL },
	{"in the testing ring for knights", 8, NULL, NULL, 15, NULL, NULL },
	{"in a rocky basin.  A wall of monoliths blocks further passage",
NULL, NULL, 4, NULL, NULL, NULL },
	{"in an inner sanctum", NULL, NULL, NULL, NULL, 9, NULL },
	{"in a cement antechamber", NULL, NULL, NULL, 12, NULL, NULL },
	{"in the royal palace", NULL, NULL, 8, NULL, NULL, NULL },
	{"in a supply shed", NULL, NULL, 10, NULL, NULL, NULL },
	{"on top of the wall of monoliths.  Across a wide crevice lies another cliff",
NULL, NULL, NULL, NULL, NULL, 11 },
	{"at the foot of an odd-looking spacecraft",
NULL, NULL, NULL, NULL, NULL, NULL },
	{"in the spaceship.  Its walls are like glass from the inside",
NULL, NULL, 17, NULL, NULL, NULL }
};

struct object ob[] =
{
	{ "", NULL, 0 },
	{ "Ave Maria", 3, 5 },
	{ "Beggar", 1, 5 },
	{ "Sword sticking from boulder", 5, 0 },
	{ "Roman legion (10 brigades)", 6, 50 },
	{ "9 Roman brigades", 0, 45 },
	{ "Blind man", 7, 5 },
	{ "Starving crowd", 8, 10 },
	{ "Young Arthur", 10, 5 },
	{ "Large cement block", 9, 0 },
	{ "King of the Jews", 14, 20 },
	{ "Metal tablet", 18, 0 },
	{ "Small slot in the wall", 13, 0 },
	{ "Dirt wall", 12, 0 },
	{ "Large circular receptor", 18, 0 },
	{ "with sphere in it", NULL, 0 },
	{ "Voice receiver (microphone)", 18, 0 },
	{ "Nickel", NULL, 0 },
	{ "Chariot", 6, 0 },
	{ "Excalibur", NULL, 0 },
	{ "Almost empty basket", 15, 0 },
	{ "Basket of bread", NULL, 0 },
	{ "Strange glider wings", 15, 0 },
	{ "Rooster bar", 15, 0 },
	{ "Glowing green sphere", NULL, 0 },
	{ "Half nickel", NULL, 0 },
	{ "Half nickel", NULL, 0 }
};

static int cp = 1;
static int score = 0;
static bool allowance = false;
static bool usingTheForce = false;
static bool split = false;
static HINSTANCE s_hInst;
static HWND s_hMainWnd, s_hEditWnd;
static HFONT s_hFont;
static int s_charHeight;

static TCHAR szRoomDescription [1024];
static TCHAR szActionDescription [2048];

static TCHAR verb_str[MAX_COMMAND_STRING];
static TCHAR noun_str[MAX_COMMAND_STRING];

enum NounType
{
	NOUN_none,
	NOUN_NORT, NOUN_SOUT, NOUN_EAST, NOUN_WEST, NOUN_UP, NOUN_DOWN,
	NOUN_MARI, NOUN_MARY,
	NOUN_BEGG,
	NOUN_BOUL,
	NOUN_LEGI, NOUN_ROMA, NOUN_BRIG,
	NOUN_MAN,
	NOUN_CROW,
	NOUN_ARTH,
	NOUN_BLOC, NOUN_CEME,
	NOUN_KING,
	NOUN_TABL,
	NOUN_SLOT,
	NOUN_DIRT, NOUN_WALL,
	NOUN_RECE,
	NOUN_MICR, NOUN_MIKE,
	NOUN_NICK, NOUN_HALF,
	NOUN_CHAR,
	NOUN_SWOR, NOUN_EXCA,
	NOUN_BASK, NOUN_BREA,
	NOUN_WING,
	NOUN_ROOS, NOUN_BAR,
	NOUN_SPHE,
	NOUN_FORC, NOUN_THE_,
	NOUN_SPAC, NOUN_SHIP,
	NOUN_GAME,
	NOUN_TRAI,
	NOUN_MONO,
	NOUN_cipher_FIRE,
	NOUN_cipher_SPLI,
	NOUN_last = NUM_NOUNS
};

static void open_something (NounType noun);
static void take (NounType noun);

static void adventure_over()
{
	ShowWindow (s_hEditWnd, SW_HIDE);
	HMENU hMenu = GetMenu (s_hMainWnd);
	EnableMenuItem (hMenu, IDM_SAVE, MF_BYCOMMAND | MF_GRAYED);
	_tcscat (szActionDescription,
		_T ("\n\nThe adventure is now over.\n\n"));
	InvalidateRect (s_hMainWnd, NULL, TRUE);
}

static void get_allowance()
{
	_tcscat (szActionDescription,
		_T("MARY: Aye, patrushka, why couldn't you have been a doctor or a\n")
		_T("    lawyer or something respectable like that?  You make a\n")
		_T("    Jewish mother very unhappy!  Oh well, yenta, here's your\n")
		_T("    allowance, but I'm never gonna be your follower!\n"));
	ob[17].room = cp;
	allowance = true;
}

static void liftoff()
{
	_tcscat (szActionDescription,
		_T("With a deep rumbling sound, followed by a rising pitch, the\n")
		_T("space ship lifts off.  After a very brief flight, the whole craft\n")
		_T("finally comes to rest and just hovers.\n"));
	p[cp].exit[EAST] = 0;
	if (ob[4].room == 6)
		ob[4].room = 18;
	else if (ob[5].room == 6)
		ob[5].room = 18;
}

static void show_score()
{
	TCHAR buf[80];

	_stprintf (buf,
		_T("You have %d percent of the population as your followers.\n"),
		score);
	_tcscat (szActionDescription, buf);
	if (score == 100)
	{
		_tcscat (szActionDescription,
			_T("You've done it!  Now, the crusade for world conquest can begin!\n"));
		adventure_over();
	}
}

static void show_room()
{
	static const TCHAR dir[][6] =
	{
		_T("North"),
		_T("South"),
		_T("East"),
		_T("West"),
		_T("Up"),
		_T("Down")
	};
	int i, j;

	if (ob[8].score == 0  &&  ob[19].room == 0)
		ob[8].room = cp;
	if (ob[8].room == cp)
		if (ob[3].room == cp)
		{
			_tcscat (szActionDescription, _T("Shing!\n"));
			ob[19].room = cp;
			ob[3].room = 0;
		}

	if (ob[1].room == cp  &&  !allowance)
		get_allowance();

	_tcscpy (szRoomDescription, _T("You are "));
	_tcscat (szRoomDescription, p[cp].name);
	_tcscat (szRoomDescription, _T("."));
	j = 0;
	for (i = 1; i <= NUM_OBJECTS; ++i)
		if (ob[i].room == cp)
		{
			if (j == 0)
			{
				_tcscat (szRoomDescription, _T("  Visible items:\n\n"));
				j = 1;
			}
			_tcscat (szRoomDescription, ob[i].name);
			_tcscat (szRoomDescription, _T(".  "));
		};
	j = 0;
	for (i = NORTH; i <= DOWN; ++i)
		if (p[cp].exit[i] != NULL)
		{
			if (j == 0)
			{
				_tcscat (szRoomDescription, _T("\n\nObvious exits:"));
				j = 1;
			}
			_tcscat (szRoomDescription, _T(" "));
			_tcscat (szRoomDescription, dir[i]);
		}

	if (cp == 4  &&  score == 100)
		show_score();
}

static bool input_command (LPCTSTR szCommand, int *verb, NounType *noun)
{
	static const TCHAR verb_table[][5] =
	{
		"",
		"N", "S", "E", "W", "U", "D",
		"GO", "CLIM",
		"GET", "TAKE", ".",
		"DROP", "PUT", "P",
		"LOOK", "EXAM", "L", "READ",
		"INVE", "I",
		"DIG",
		"PULL",
		"USE",
		"INSE",
		"RAIS", "LIFT",
		"OPEN",
		"GLID", "FLY",
		"GIVE",
		"SAY",
		"HELP",
		"QUIT",
		"RIDE",
		"HEAL",
		"SCOR",
		"SAVE",
		"LOAD",
		"BREA"
	};
	static const TCHAR noun_table[][5] =
	{
		"",
		"NORT", "SOUT", "EAST", "WEST", "UP", "DOWN",
		"MARI", "MARY",
		"BEGG",
		"BOUL",
		"LEGI", "ROMA", "BRIG",
		"MAN",
		"CROW",
		"ARTH",
		"BLOC", "CEME",
		"KING",
		"TABL",
		"SLOT",
		"DIRT", "WALL",
		"RECE",
		"MICR", "MIKE",
		"NICK", "HALF",
		"CHAR",
		"SWOR", "EXCA",
		"BASK", "BREA",
		"WING",
		"ROOS", "BAR",
		"SPHE",
		"FORC", "THE ",
		"SPAC", "SHIP",
		"GAME",
		"TRAI",
		"MONO",
		"%2$*",
		"/>+2"
	};
	int i;
	verb_str[0] = _T('\0');
	noun_str[0] = _T('\0');

	_tcscat (szActionDescription, _T("  ------> What now? "));
	_tcscat (szActionDescription, szCommand);
	_tcscat (szActionDescription, _T("\n"));
	i = 0;
	while (szCommand[i] != '\0' && szCommand[i] != ' ')
		++i;
	strncpy(verb_str, szCommand, i);
	verb_str[i] = _T('\0');
	if (i < 30)
	{
		LPCTSTR temp = szCommand + i;
		while (*temp == ' ' && *temp != '\0')
			++ temp;
		if (*temp != '\0')
			strcpy (noun_str, temp);
	}
	i = 1;
	while (i <= NUM_VERBS && strnicmp(verb_str, verb_table[i], 4))
		++i;
	if (i <= NUM_VERBS)
		*verb = i;
	else
	{
		_tcscat (szActionDescription, _T("I don't know how to \""));
		_tcscat (szActionDescription, verb_str);
		_tcscat (szActionDescription, _T("\" something.\n"));
		return false;
	}
	if (!noun_str[0])
	{
		*noun = NOUN_none;
		return true;
	}
	register NounType n = NOUN_NORT;
	while (n <= NOUN_last  &&  strnicmp(noun_str, noun_table[n], 4))
		n = (NounType) (n + 1);
	if (n <= NUM_NOUNS)
	{
		*noun = n;
		return true;
	}
	else
	{
		_tcscat (szActionDescription, _T("I don't know what \""));
		_tcscat (szActionDescription, noun_str);
		_tcscat (szActionDescription, _T("\" is.\n"));
		return false;
	}
}

//
// message display functions
//

static void ok()
{
	_tcscat (szActionDescription, _T("Ok\n"));
}

static void verb_what()
{
	_tcscat (szActionDescription, verb_str);
	_tcscat (szActionDescription, _T(" what?\n"));
}

static void nothing_special()
{
	_tcscat (szActionDescription, _T("You see nothing special.\n"));
}

static void dont_see_it()
{
	_tcscat (szActionDescription, _T("You don't see it here.\n"));
}

static void not_holding_it()
{
	_tcscat (szActionDescription, _T("You aren't holding it.\n"));
}

static void beyond_your_power()
{
	_tcscat (szActionDescription, _T("It's beyond your power to do that.\n"));
}

static void not_yet()
{
	_tcscat (szActionDescription, _T("You can't do that . . . yet!\n"));
}

static void I_will_be_your_follower()
{
	_tcscat (szActionDescription, _T("\"I will be your follower.\"\n"));
}

static void nothing_happens()
{
	_tcscat (szActionDescription, _T("Nothing happens.\n"));
}

static void being_weird()
{
	_tcscat (szActionDescription, _T("Oh, stop being weird.\n"));
}

static void already_done_that()
{
	_tcscat (szActionDescription, _T("You've already done that.\n"));
}

//
// verb handler functions
//

static void move_dir(enum direction direc)
{
	if (p[cp].exit[direc] == 0)
		_tcscat (szActionDescription, _T("There is no way to go that direction.\n"));
	else
	{
		cp = p[cp].exit[direc];
		ok();
	}
}

static void go (NounType noun)
{
	switch(noun)
	{
		case NOUN_none:
			verb_what();
			break;
		case NOUN_NORT:
			move_dir(NORTH);
			break;
		case NOUN_SOUT:
			move_dir(SOUTH);
			break;
		case NOUN_EAST:
			move_dir(EAST);
			break;
		case NOUN_WEST:
			move_dir(WEST);
			break;
		case NOUN_UP:
			move_dir(UP);
			break;
		case NOUN_DOWN:
			move_dir(DOWN);
			break;
		case NOUN_SPAC:
		case NOUN_SHIP:
			if (cp != 17)
				dont_see_it();
			else
				cp = 18;
			break;
		case NOUN_TRAI:
			if (cp == 4  ||  cp == 2)
				_tcscat (szActionDescription, _T("Sorry, that's for horses.\n"));
			else
				dont_see_it();
			break;
		case NOUN_MONO:
		case NOUN_WALL:
			if (cp != 11)
				dont_see_it();
			else if (ob[18].room == HELD)
				_tcscat (szActionDescription,
					_T("You can't.  You're holding something much too heavy.\n"));
			else
			{
				ok();
				cp = 16;
			}
			break;
		default:
			being_weird();
	}
}

static void look (NounType noun)
{
	switch (noun)
	{
		case NOUN_none:
			break;
		case NOUN_NICK:
			if (ob[17].room != HELD)
				not_holding_it();
			else
				_tcscat (szActionDescription, _T("It has a weak seam.\n"));
			break;
		case NOUN_TABL:
			if (ob[11].room != cp)
				not_yet();
			else
				_tcscat (szActionDescription,
					_T("It's in some alien language:\n")
					_T("7(2/  2/  <[*  <%  7(*  ;</7  ><1*$%9+  /(2>/  2[  *-2/7*['* ,\n")
					_T("'<;>+*7*  127(  %+52[&  #:2+272*/  #[@  #  ;2//2+*  #77#'!2[&\n")
					_T("/5/7*;  7(#7  (#/  />+2772[&  '#>#:2+272*/ .  #++  7(*  1<$!\n")
					_T("2/  '<;>97*$  #[@  0<2'*  '<[7$<++*@ .\n"));
			break;
		default:
			nothing_special();
	}
}

static void inventory()
{
	int i;
	LPCTSTR last = _T("nothing at all");

	_tcscat (szActionDescription,
		_T("You are currently holding the following:\n"));
	for (i = 17; i <= NUM_OBJECTS; ++i)
		if (ob[i].room == HELD)
		{
			last = "";
			_tcscat (szActionDescription, ob[i].name);
			_tcscat (szActionDescription, _T(".  "));
		};
	_tcscat (szActionDescription, last);
	_tcscat (szActionDescription, _T("\n"));
}

static void dig (NounType noun)
{
	if (noun != NOUN_DIRT  &&  noun != NOUN_WALL)
		nothing_special();
	else if (ob[13].room != cp)
		dont_see_it();
	else
	{
		ok();
		ob[13].room = 0;
		p[cp].exit[EAST] = 13;
	}
}

static void pull (NounType noun)
{
	switch (noun)
	{
		case NOUN_BLOC:
		case NOUN_CEME:
			open_something (noun);
			break;
		case NOUN_SPHE:
			take (noun);
			break;
		case NOUN_SWOR:
		case NOUN_EXCA:
			if (ob[19].room == cp)
			{
				ok();
				ob[19].room = HELD;
			}
			else if (ob[3].room != cp)
				dont_see_it();
			else
			_tcscat (szActionDescription,
				_T("Harrumph!  It's no use, you can't do it.\n"));
			break;
		default:
			being_weird();
	}
}

static void use (NounType noun)
{
	switch (noun)
	{
		case NOUN_none:
			verb_what();
			break;
		case NOUN_FORC:
		case NOUN_THE_:
			if (ob[1].room == cp)
				if (ob[1].score == 0)
					nothing_happens();
				else
				{
					score += ob[1].score;
					ob[1].score = 0;
					ok();
					_tcscat (szActionDescription, _T("\"Well, OK, son --\"\n"));
					I_will_be_your_follower();
				}
			else if (ob[8].room == cp)
				if (ob[8].score == 0)
					nothing_happens();
				else
				{
					score += ob[8].score;
					ob[8].score = 0;
					I_will_be_your_follower();
				}
			else if (ob[4].room == cp)
				if (usingTheForce)
					nothing_happens();
				else
				{
					_tcscat (szActionDescription,
						_T("Hmmm ... somehow, they're all looking the other way....\n"));
					usingTheForce = true;
				}
			else
				nothing_happens();
			break;
		default:
			nothing_happens();
	}
}

static void insert (NounType noun)
{
	switch (noun)
	{
		case NOUN_none:
			verb_what();
			break;
		case NOUN_SPHE:
			if (ob[24].room != HELD)
				not_holding_it();
			else if (ob[14].room != cp)
				not_yet();
			else
			{
				ok();
				ob[24].room = 0;
				ob[15].room = cp;
				liftoff();
			}
			break;
		case NOUN_NICK:
		case NOUN_HALF:
			if (ob[17].room != HELD  &&
				ob[25].room != HELD  &&
				ob[26].room != HELD)
					not_holding_it();
			else if (ob[12].room != cp)
				not_yet();
			else
			{
				if (ob[17].room == HELD)
					ob[17].room = 0;
				else if (ob[25].room == HELD)
					ob[25].room = 0;
				else
					ob[26].room = 0;
				ok();
				ob[24].room = cp;
				_tcscat (szActionDescription,
					_T("Something materialized out of nowhere.\n"));
			}
			break;
		default:
			being_weird();
	}
}

static void raise_something (NounType noun)
{
	switch (noun)
	{
		case NOUN_none:
			verb_what();
			break;
		case NOUN_BLOC:
		case NOUN_CEME:
			open_something (noun);
			break;
		case NOUN_BASK:
			if (ob[21].room == HELD)
				already_done_that();
			else if (ob[20].room != HELD)
				not_holding_it();
			else
			{
				_tcscat (szActionDescription,
					_T("... and suddenly, ** P O W ! ! ! **\n"));
				ob[21].room = HELD;
				ob[20].room = 0;
				inventory();
			}
			break;
		default:
			beyond_your_power();
	}
}

static TCHAR szWithWhat[MAX_COMMAND_STRING];
// Message handler for "With what?" dialog box.
static BOOL CALLBACK WithWhat(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				GetDlgItemText (hDlg, IDC_EDIT_WITH_WHAT, szWithWhat, 5);
				szWithWhat[4] = _T('\0');
				EndDialog(hDlg, IDOK);
				return TRUE;
			}
			break;
	}
	return FALSE;
}

static void open_something (NounType noun)
{
	switch (noun)
	{
		case NOUN_none:
			verb_what();
			break;
		case NOUN_BLOC:
		case NOUN_CEME:
			if (p[9].exit[DOWN] == 12)
				already_done_that();
			else if (ob[9].room != cp)
				dont_see_it();
			else
			{
				DialogBox (s_hInst, (LPCTSTR) IDD_WITH_WHAT,
							s_hMainWnd, (DLGPROC) WithWhat);
				if (stricmp (szWithWhat, _T("ROOS"))  &&
					stricmp (szWithWhat, _T("BAR")))
						_tcscat (szActionDescription,
							_T("Sorry, it's too heavy.\n"));
				else if (ob[23].room != HELD)
					not_holding_it();
				else
				{
					_tcscat (szActionDescription,
						_T("With the slow grind of concrete-on-concrete, ")
						_T("the block slides away.  A hole remains.\n"));
					p[9].exit[DOWN] = 12;
				}
			}
			break;
		default:
			beyond_your_power();
	}
}

static void glide()
{
	if (ob[22].room != HELD)
	{
		_tcscat (szActionDescription,
			_T("Sorry.  You may have a lot of powers, but\n"));
		not_yet();
	}
	else if (cp != 17  &&  cp != 16)
		_tcscat (szActionDescription,
			_T("Believe me, you don't need to fly now.\n"));
	else
	{
		_tcscat (szActionDescription,
			_T("Wheeeeeee!  This is almost as much fun as ... well ...\n"));
		if (cp == 16)
			cp = 17;
		else
			cp = 16;
	}
}

static void say (NounType noun)
{
	if (noun == NOUN_none)
		verb_what();
	else
	{
		_tcscat (szActionDescription, _T("Ok: \""));
		_tcscat (szActionDescription, noun_str);
		_tcscat (szActionDescription, _T("\"\n"));
		if (cp == 18  &&  ob[15].room != 0)
		{
			if (noun == NOUN_cipher_SPLI)
			{
				_tcscat (szActionDescription,
					_T("A mechanical voice intones, \"<!\"\n"));
				split = true;
			}
			if (noun == NOUN_cipher_FIRE)
			{
				_tcscat (szActionDescription,
					_T("A sizzling missile streaks from the bottom of the ship.\n"));
				if (split)
				{
					_tcscat (szActionDescription,
						_T("It splits into ten fragments in mid-flight, and\n"));
					if (ob[4].room == 0  &&  ob[5].room == 0)
						_tcscat (szActionDescription,
							_T("strikes the ground harmlessly.\n"));
					else
					{
						_tcscat (szActionDescription,
							_T("destroys the entire Roman legion!\n"));
						if (ob[4].room == 0)
						{
							score += ob[5].score;
							ob[5].score = 0;
							ob[5].room = 0;
						}
						else
						{
							score += ob[4].score;
							ob[4].score = 0;
							ob[4].room = 0;
						}
					}
				}
				else if (ob[4].room == cp)
				{
					_tcscat (szActionDescription,
						_T("It hits the Roman legion, killing one of the brigades.\n"));
					ob[5].room = cp;
					ob[4].room = 0;
					score += ob[4].score / 10;
				}
				else
					_tcscat (szActionDescription,
						_T("It misses the 9 brigades completely.\n"));
			}
		}
	}
}

static void help()
{
	if (cp == 18)
		_tcscat (szActionDescription,
			_T("Maybe the message is a cryptogram.\n"));
	else
		_tcscat (szActionDescription,
			_T("Like the movie says, \"Use the force....\"\n"));
}

static void ride (NounType noun)
{
	if (noun != NOUN_none  &&  noun != NOUN_CHAR)
		being_weird();
	else if (ob[18].room != cp)
		not_yet();
	else if (cp != 2  &&  cp != 4)
		_tcscat (szActionDescription, _T("Save it for later.\n"));
	else
	{
		_tcscat (szActionDescription, _T("Yaah, boy! (Crack!)\n"));
		if (cp == 2)
			cp = 4;
		else
			cp = 2;
		ob[18].room = cp;
	}
}

static void heal (NounType noun)
{
	if (noun == NOUN_none)
		verb_what();
	else if (noun != NOUN_MAN)
		beyond_your_power();
	else if (ob[6].room != cp)
		dont_see_it();
	else
	{
		_tcscat (szActionDescription,
			_T("Wow!  It's a mir-acle!  He leaves, and says,\n"));
		score += ob[6].score;
		ob[6].score = 0;
		ob[6].room = 0;
		I_will_be_your_follower();
	}
}

static void write_game()
{
	TCHAR			fn [MAX_PATH];
	OPENFILENAME	ofn;

	fn[0] = _T('\0');
	ofn.lStructSize = sizeof ofn;
	ofn.hwndOwner = s_hMainWnd;
	ofn.hInstance = s_hInst;
	ofn.lpstrFilter = _T("Save files (*.sav)\0*.sav\0All files (*.*)\0*.*\0");
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = NULL;
	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;
	ofn.lpstrDefExt = _T("sav");
	ofn.lCustData = 0;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	if (!GetSaveFileName (&ofn))
		return;

	FILE *fp;
	if ((fp = fopen(fn, "w")) == NULL)
		MessageBox (s_hMainWnd,
			_T("File creation error.  Save aborted."), NULL, MB_OK);
	else
	{
		for (int i = 1; i <= NUM_OBJECTS; ++i)
		{
			fwrite(&ob[i].room, sizeof(int), 1, fp);
			fwrite(&ob[i].score, sizeof(int), 1, fp);
		}
		fwrite(&cp, sizeof(int), 1, fp);
		fwrite(&score, sizeof(int), 1, fp);
		fwrite(&allowance, sizeof(bool), 1, fp);
		fwrite(&usingTheForce, sizeof(bool), 1, fp);
		fwrite(&split, sizeof(bool), 1, fp);
		fwrite(&p[18].exit[EAST], sizeof(int),1, fp);
		fwrite(&p[12].exit[EAST], sizeof(int), 1, fp);
//		fwrite(&p[15].exit[DOWN],sizeof(int),1, fp);
//		fwrite(&p[6].exit[EAST], sizeof(int),1, fp);
		fwrite(&p[9].exit[DOWN], sizeof(int),1, fp);
		fclose(fp);
	}
}

static void save_game(NounType noun)
{
	if (noun != 0 && noun != 63)
		_tcscat (szActionDescription, _T("You can't save that!\n"));
	else
		write_game();
}

static BOOL restore_game()
{
	TCHAR			fn [MAX_PATH];
	OPENFILENAME	ofn;

	fn[0] = _T('\0');
	ofn.lStructSize = sizeof ofn;
	ofn.hwndOwner = s_hMainWnd;
	ofn.hInstance = s_hInst;
	ofn.lpstrFilter = _T("Save files (*.sav)\0*.sav\0All files (*.*)\0*.*\0");
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = NULL;
	ofn.Flags = 0;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;
	ofn.lpstrDefExt = NULL;
	ofn.lCustData = 0;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	if (!GetOpenFileName (&ofn))
		return FALSE;

	FILE *fp;
	if ((fp = fopen(fn, "r")) == NULL)
		MessageBox (s_hMainWnd,
			_T("Error opening file.  Load aborted."), NULL, MB_OK);
	else
	{
		for (int i = 1; i <= NUM_OBJECTS; ++i)
		{
			fread (&ob[i].room, sizeof(int), 1, fp);
			fread (&ob[i].score, sizeof(int), 1, fp);
		}
		fread (&cp, sizeof(int), 1, fp);
		fread (&score, sizeof(int), 1, fp);
		fread (&allowance, sizeof(bool), 1, fp);
		fread (&usingTheForce, sizeof(bool), 1, fp);
		fread (&split, sizeof(bool), 1, fp);
		fread (&p[18].exit[EAST], sizeof(int), 1, fp);
		fread (&p[12].exit[EAST], sizeof(int), 1, fp);
//		fread (&p[15].exit[DOWN], sizeof(int), 1, fp);
//		fread (&p[6].exit[EAST], sizeof(int), 1, fp);
		fread (&p[9].exit[DOWN], sizeof(int), 1, fp);
		fclose (fp);
		_tcscpy (szActionDescription, _T("Game restored.\n"));
		show_room();
		return TRUE;
	}
	return FALSE;
}

static void load_game(NounType noun)
{
	if (noun != 0 && noun != 63)
		_tcscat (szActionDescription, _T("You can't load that!\n"));
	else
		restore_game();
}

static void break_something (NounType noun)
{
	if (noun == NOUN_none)
		verb_what();
	else if (noun != NOUN_NICK)
		beyond_your_power();
	else if (ob[17].room != HELD)
		not_holding_it();
	else
	{
		ok();
		ob[17].room = NULL;
		ob[25].room = HELD;
		ob[26].room = HELD;
	}
}

inline void td_not_there (int from)
{
	if (from == HELD)
		not_holding_it();
	else
		dont_see_it();
}

static void td_do (int from, int to, int object)
{
	if (ob[object].room != from)
		td_not_there (from);
	else
	{
		ok();
		ob[object].room = to;
	}
}

static void take_drop (NounType noun, int from, int to)
{
	switch (noun)
	{
		case NOUN_NICK:
		case NOUN_HALF:
			if (ob[25].room == from)
			{
				ok();
				if (ob[2].room == cp)
				{
					score += ob[2].score;
					ob[2].score = 0;
					ob[25].room = 0;
					I_will_be_your_follower();
				}
				else
					ob[25].room = to;
			}
			else if (ob[26].room == from)
			{
				ok();
				if (ob[2].room == cp)
				{
					score += ob[2].score;
					ob[2].score = 0;
					ob[26].room = 0;
					I_will_be_your_follower();
				}
				else
					ob[26].room = to;
			}
			else if (ob[17].room == from)
			{
				ok();
				if (ob[2].room == cp)
				{
					score += ob[2].score;
					ob[2].score = 0;
					ob[17].room = 0;
					I_will_be_your_follower();
				}
				else
					ob[17].room = to;
			}
			else
				td_not_there (from);
			break;
		case NOUN_CHAR:
			if (ob[18].room != from)
				td_not_there (from);
			else if (ob[4].room == cp  &&  !usingTheForce)
			{
				_tcscat (szActionDescription,
					_T("Caught!  You're crucified by the Romans!\n"));
				adventure_over();
			}
			else
			{
				ok();
				ob[18].room = to;
			}
			break;
		case NOUN_SWOR:
		case NOUN_EXCA:
			if (ob[3].room == from  &&  from == cp)
				pull (noun);
			else if (ob[19].room != from)
				td_not_there (from);
			else
			{
				ok();
				ob[19].room = to;
				if (ob[10].room == cp  &&  score > 0)
				{
					_tcscat (szActionDescription,
						_T("\"My lord!  My people and\"\n"));
					score += ob[10].score;
					ob[10].score = 0;
					I_will_be_your_follower();
				}
			}
			break;
		case NOUN_BASK:
		case NOUN_BREA:
			if (ob[20].room == from)
			{
				ok();
				ob[20].room = to;
			}
			else if (ob[21].room != from)
				td_not_there (from);
			else
			{
				ok();
				ob[21].room = to;
				if (ob[7].room == cp)
				{
					_tcscat (szActionDescription,
						_T("They love it!  They gobble it up, leave, and all say:\n"));
					ob[20].room = ob[21].room;
					ob[21].room = 0;
					score += ob[7].score;
					ob[7].score = 0;
					ob[7].room = 0;
					I_will_be_your_follower();
				}
			}
			break;
		case NOUN_WING:
			td_do(from, to, 22);
			break;
		case NOUN_ROOS:
		case NOUN_BAR:
			td_do(from, to, 23);
			break;
		case NOUN_SPHE:
			if (ob[24].room == from)
			{
				ok();
				ob[24].room = to;
			}
			else if (ob[15].room != from)
				td_not_there (from);
			else
			{
				ok();
				ob[15].room = 0;
				ob[24].room = to;
				_tcscat (szActionDescription,
					_T("The space ship lands where it took off.\n"));
				p[cp].exit[EAST] = 17;
				if (ob[4].room == cp)
					ob[4].room = 6;
				else if (ob[5].room == cp)
					ob[5].room = 6;
			}
			break;
	}
}

static void take (NounType noun)
{
	int from, to;

	if (noun == NOUN_none)
		verb_what();
	else if (noun <= NOUN_UP)
		_tcscat (szActionDescription, _T("I don't get it.\n"));
	else if (noun == NOUN_DOWN)
		_tcscat (szActionDescription, _T(". . . and boogie!\n"));
	else if (noun < NOUN_NICK  ||  noun > NOUN_SPHE)
		beyond_your_power();
	else
	{
		to = 0;
		for (from = 17; from <= NUM_OBJECTS; ++from)
			if (ob[from].room == HELD)
				++to;
		if (to >= MAXINV)
			_tcscat (szActionDescription,
				_T("You are currently holding too much.  Try: INVENTORY\n"));
		else
		{
			from = cp;
			to = HELD;
			take_drop(noun, from, to);
		}
	}
}

static void drop(NounType noun)
{
	int from, to;

	if (noun == NOUN_none)
		verb_what();
	else if (noun <= NOUN_DOWN)
		_tcscat (szActionDescription, _T("Oh, just drop it.\n"));
	else if (noun < NOUN_NICK  ||  noun > NOUN_SPHE)
		not_holding_it();
	else
	{
		from = HELD;
		to = cp;
		take_drop(noun, from, to);
	}
}

// Master verb function chooser, derived from BASIC on-goto statement.
static void do_command(int verb, NounType noun)
{
	switch(verb)
	{
		case 1:
			move_dir(NORTH);
			break;
		case 2:
			move_dir(SOUTH);
			break;
		case 3:
			move_dir(EAST);
			break;
		case 4:
			move_dir(WEST);
			break;
		case 5:
			move_dir(UP);
			break;
		case 6:
			move_dir(DOWN);
			break;
		case 7: case 8:
			go(noun);
			break;
		case 9: case 10: case 11:
			take(noun);
			break;
		case 12: case 13: case 14: case 30:
			drop(noun);
			break;
		case 15: case 16: case 17: case 18:
			look(noun);
			break;
		case 19: case 20:
			inventory();
			break;
		case 21:
			dig (noun);
			break;
		case 22:
			pull (noun);
			break;
		case 23:
			use (noun);
			break;
		case 24:
			insert (noun);
			break;
		case 25: case 26:
			raise_something (noun);
			break;
		case 27:
			open_something (noun);
			break;
		case 28: case 29:
			glide();
			break;
		case 31:
			say (noun);
			break;
		case 32:
			help();
			break;
		case 33:
			adventure_over();
			break;		/* not necessary, but pretty-looking */
		case 34:
			ride (noun);
			break;
		case 35:
			heal (noun);
			break;
		case 36:
			show_score();
			break;
		case 37:
			save_game (noun);
			break;
		case 38:
			load_game (noun);
			break;
		case 39:
			break_something (noun);
			break;
	}
	show_room();
}


// Message handler for about box.
static BOOL CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
	return FALSE;
}

static void trim_action_text()
{
	while (_tcslen (szActionDescription) > 1024)
	{
		LPCTSTR p = _tcschr (szActionDescription, _T('\n'));
		if (!p)
			return;
		TCHAR buf[2048];
		_tcscpy (buf, p + 1);
		_tcscpy (szActionDescription, buf);
	}
}


// Message handler for subclassed edit control.
static WNDPROC pOriginalEditProc;
static LRESULT CALLBACK EditControlWndProc
	(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message == WM_CHAR  &&  (TCHAR) wParam == _T('\r'))
	{
		PostMessage (GetParent(hWnd), WM_COMMAND,
			MAKELONG (GetWindowLong (hWnd, GWL_ID), EN_USERPRESSEDENTER),
			(LPARAM) hWnd);
		return 0;
	}
	return CallWindowProc (pOriginalEditProc, hWnd, message, wParam, lParam);
}

// Message handler for main window.
static LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message) 
	{
		case WM_CREATE:
		{
			RECT r;
			GetClientRect (hWnd, &r);
			s_hEditWnd = CreateWindow
				("EDIT", "", WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT,
				120, r.bottom - s_charHeight - 4, 200, s_charHeight + 3,
				hWnd, (HMENU) IDC_EDIT, s_hInst, NULL);
			pOriginalEditProc = (WNDPROC) GetWindowLong (s_hEditWnd, GWL_WNDPROC);
			SetWindowLong (s_hEditWnd, GWL_WNDPROC, (LONG) EditControlWndProc);
			SendMessage (s_hEditWnd, WM_SETFONT, (WPARAM) s_hFont, 0);
			SendMessage (s_hEditWnd, EM_LIMITTEXT, MAX_COMMAND_STRING - 1, 0);
			break;
		}
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
					DialogBox (s_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
					break;
				case IDM_EXIT:
					PostMessage (hWnd, WM_CLOSE, 0, 0);
					break;
				case IDM_SAVE:
					write_game();
					InvalidateRect (hWnd, NULL, TRUE);
					break;
				case IDM_LOAD:
					if (restore_game())
					{
						HMENU hMenu = GetMenu (s_hMainWnd);
						EnableMenuItem (hMenu, IDM_SAVE, MF_BYCOMMAND | MF_ENABLED);
						if (!IsWindowVisible (s_hEditWnd))
							ShowWindow (s_hEditWnd, SW_SHOW);
					}
					InvalidateRect (hWnd, NULL, TRUE);
				case IDC_EDIT:
					if (wmEvent == EN_USERPRESSEDENTER)
					{
						TCHAR buf [MAX_COMMAND_STRING];
						int	verb;
						NounType noun;

						GetWindowText ((HWND) lParam, buf, MAX_COMMAND_STRING);
						if (input_command (buf, &verb, &noun))
							do_command(verb, noun);
						SetWindowText ((HWND) lParam, _T(""));
						InvalidateRect (hWnd, NULL, TRUE);
						trim_action_text();
						break;
					}
					/* fall through */
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			LPCTSTR szWhatNow = _T("  ------> What now? ");
			HDC hdc = BeginPaint(hWnd, &ps);
			RECT r, rt;
			GetClientRect(hWnd, &rt);
			r = rt;
			SelectObject (hdc, s_hFont);
			int actionTextHeight = DrawText (
				hdc, szActionDescription, _tcslen (szActionDescription), &r,
				DT_WORDBREAK | DT_NOPREFIX | DT_CALCRECT);
			r.bottom = rt.bottom - s_charHeight;
			r.top = r.bottom - actionTextHeight;
			DrawText (
				hdc, szActionDescription, _tcslen (szActionDescription), &r,
				DT_WORDBREAK | DT_NOPREFIX);
			r = rt;
			int roomTextHeight = DrawText (
				hdc, szRoomDescription, _tcslen (szRoomDescription), &r,
				DT_WORDBREAK | DT_NOPREFIX | DT_CALCRECT);
			r = rt;
			r.bottom = roomTextHeight + 5;
			FillRect (hdc, &r, (HBRUSH)GetStockObject(WHITE_BRUSH));
			DrawText (
				hdc, szRoomDescription, _tcslen (szRoomDescription), &rt,
				DT_WORDBREAK | DT_NOPREFIX);
			SelectObject (hdc, (HPEN) GetStockObject (BLACK_PEN));
			MoveToEx (hdc, 0, roomTextHeight + 5, NULL);
			LineTo (hdc, rt.right, roomTextHeight + 5);
			if (s_hEditWnd  &&  IsWindowVisible (s_hEditWnd))
			{
				SetTextAlign (hdc, TA_LEFT | TA_BOTTOM);
				TextOut (hdc, 0, rt.bottom, szWhatNow, _tcslen (szWhatNow));
			}
			EndPaint(hWnd, &ps);
			break;
		}
		case WM_SETFOCUS:
		{
			if (IsWindowVisible (s_hEditWnd))
				SetFocus (s_hEditWnd);
			break;
		}
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// And now, a function that needs no introduction:
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR szWindowClass[MAX_LOADSTRING];

	s_hInst = hInstance; // Store instance handle in our file-level-static variable
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_FOLLOWERS, szWindowClass, MAX_LOADSTRING);
	if (!hPrevInstance)
	{
		WNDCLASSEX wcex;

		wcex.cbSize = sizeof(WNDCLASSEX); 

		wcex.style			= CS_HREDRAW | CS_VREDRAW;
		wcex.lpfnWndProc	= (WNDPROC)WndProc;
		wcex.cbClsExtra		= 0;
		wcex.cbWndExtra		= 0;
		wcex.hInstance		= hInstance;
		wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_FOLLOWERS);
		wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
		wcex.lpszMenuName	= (LPCSTR)IDC_FOLLOWERS;
		wcex.lpszClassName	= szWindowClass;
		wcex.hIconSm		= NULL;	// LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

		if (!RegisterClassEx(&wcex))
			return FALSE;
	}

	s_hFont = CreateFont (18, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		VARIABLE_PITCH | FF_ROMAN, _T("Times New Roman"));
	HDC hDC = GetDC (NULL);
	SelectObject (hDC, s_hFont);
	TEXTMETRIC tm;
	GetTextMetrics (hDC, &tm);
	ReleaseDC (NULL, hDC);
	s_charHeight = tm.tmHeight + tm.tmExternalLeading;

	_tcscpy (szActionDescription,
		_T("You are convinced that you are the savior of all ")
		_T("mankind.  To be this, though, you must convince ")
		_T("*everyone* in your country of this before you can ")
		_T("conquer the whole world in a crusade.\n\n")
		_T("(I know the verb RAISE.)\n"));
	show_room();

	s_hMainWnd = CreateWindow (szWindowClass, szTitle,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT, 0, 600,
		s_charHeight * 25 + 2 +
			GetSystemMetrics (SM_CYCAPTION) + GetSystemMetrics (SM_CYMENU),
		NULL, NULL, hInstance, NULL);
	if (!s_hMainWnd)
		return FALSE;
	ShowWindow (s_hMainWnd, nCmdShow);
	UpdateWindow (s_hMainWnd);

	HACCEL hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_FOLLOWERS);
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	DeleteObject (s_hFont);
	return msg.wParam;
}
